#include "ep_lib.hpp"
#include <mpi.h>
#include "ep_declaration.hpp"
#include "ep_mpi.hpp"

extern MPI_Group MPI_GROUP_WORLD;

namespace ep_lib
{



  int MPI_Init_thread(int *argc, char*** argv, int required, int*provided)
  {
    Debug("MPI_Init_thread with EP/MPI\n");

    if(omp_get_thread_num() == 0)
    {
      ::MPI_Init_thread(argc, argv, required, provided);
      ::MPI_Comm_group(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &MPI_GROUP_WORLD);
    }
  }

  int MPI_Init(int *argc, char ***argv)
  {
    Debug("MPI_Init with EP/MPI\n");

    if(omp_get_thread_num() == 0)
    {
      ::MPI_Init(argc, argv);
    }
  }

  int MPI_Initialized(int *flag)
  {
    Debug("MPI_Initialized with EP/MPI\n");

    return ::MPI_Initialized(flag);
  }



}


